<html href="/context.html" lang="en" etag="QmYhU2CzzSvcr6cP8RVkVW8QKzmThpFfFnPVUpZpyYXgsL"><head>
    <!--<base href="ipns://situs.run/" />-->
    <link rel="icon" type="image/svg+xml" href="/$/icon/S.svg">
    <title>ReadMe</title>
    <meta charset="utf-8">
    <meta author="@yarrow">
    <meta license="CC0-1.0">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="/$/style/base.css">
    <script type="module" src="/$/entry.mjs"></script>
  </head>
  <body>
    <header href="/$/template/header.html" etag="QmamS41fxX6cPXUaTep65ue5AsAQEUWyPyC2tV1PkduQjL" scope="A3c8h6j">
    <nav><ul>
        <li><a href="/ReadMe">ReadMe</a></li>
        <li><a href="/EditMe">EditMe</a></li>
    </ul></nav>

    <!--<navigation>
        <a href="/ReadMe" target="main> article">ReadMe</a>
        <a href="/EditMe" target="main> article">EditMe</a>
    </navigation>-->

    <menu>
        <dynamic-icon id="switch-theme" href="/$/template/switch-light-dark.html" src="/$/icon/glasses-bold-solar.svg" etag="QmcymPYoPWcFX6mLF6EbWnXo5ta77MnnjFjD6E2qGJ6eQ3" scope="u9lkhv">
    <meta name="description" content="Switches between light and dark modes.">
<style scoped="">
[scope~="u9lkhv"] {
    height: 1.75em;

    &:hover {
        cursor: pointer;
    }
}
</style>
<script applied="">
console.log('this is the light-dark switch!', this, Boolean(this instanceof Element))

if (this instanceof Element) {
    console.log('applied!', this, document, document.body)
    const $ = (/** @type {HTMLElement} */ (this))

    const setMode = (mode) => {
        console.log('setMode:', document.body)
        $.setAttribute('switch', mode)
        $.setAttribute('src', (mode === 'dark')
            ? '/$/icon/glasses-linear-solar.svg'
            : '/$/icon/glasses-bold-solar.svg')

        document.body?.setAttribute('theme', mode)
        localStorage.setItem('theme', mode)
    }

    const switchMode = () =>
        setMode(($.getAttribute('switch') === 'dark') ? 'light' : 'dark')

    setMode(localStorage.getItem('theme') || 'light')
    $.addEventListener('click', (e) => {
        console.log('clicked!', this)
        startViewTransition(switchMode)
    })
}
</script>
</dynamic-icon>
        <dynamic-icon id="explore" src="/$/icon/move-to-folder-bold-solar.svg"></dynamic-icon>
    </menu>

<style scoped="">
[scope~="A3c8h6j"]:is(header) {
    display: flex;
    &> nav> ul {
        display: flex;
        list-style-type: none;
        &> li {
            padding-right: 1em;

            & dynamic-icon {
                width: 1.5em;
            }
        }
    }
    & #explore {
        position: absolute;
        top: 1em; left: 1em;
    }
    & #switch-theme {
        position: absolute;
        top: 1em; right: 1em;
    }
}
</style>
</header>
    <main>
        <article href="./article.html" editable="" scope="ar1h6t" title="ReadMe" etag="QmZQLWyqAe6YhUkmziLbFz7p8rFbmqmN62j8UpDXG4s8yi"> 
    <a href="#clickMe"></a>
    <h1>Situs</h1>
    <img src="/$/image/email-me.gif" style="margin:auto; display:block;">
    <h2 style="text-align: center;">the <i>hypertext editor</i> for <u>you</u></h2>
    <p>Situs is an in-browser web authoring framework for independent authors.</p>
    <nav>
        <a href="https://gitlab.com/Indy_Web/LiveEditor/demo">
            <gitlab-color-icon class="icon"></gitlab-color-icon>
            <span>GitLab</span>
        </a>
        <a href="https://t.me/+yLvW64tSa3dkN2Rh">
            <telegram-color-icon class="icon"></telegram-color-icon>
            <span>Telegram</span>
        </a>
        <a href="https://handshake.org/">
            <handshake-icon class="icon"></handshake-icon>
            <span>Handshake</span>
        </a>
    </nav>
    <p><b>Situs runs in the browser</b>, because we believe that for most folks writing code <i>with great DX</i> gets in the way of the creative process of just <i>writing</i> for the web. We're focused on HX, the human experience. Weehoo! Let's do this!</p>
    <p>We want to deliver a no-code authoring platform for your creativity, served P2P with no gateway authority in between. We're making this possible with a codebase that is built with 100% web-native standards and thus avoids the need for a "build" step, which require a running host, and/or development environment, and gets into code really fast.</p>
    <p>We're building a simple authoring framework that runs in the browser with no corporate gatekeeper —<i>you are</i> the authority.</p>
    <p>We're building with web-native technologies:
        </p><ul>
            <li><code>.html</code>, not JSON APIs, as the <i>hypertext medium</i> of choice.</li>
            <li><code>.css</code> without a preprocessor now has nested selectors 💓.</li>
            <li><code>.js</code> with JSdoc annotations for linting and type-<i>sanity</i>.</li>
        </ul>
    <p></p>
    <p>Check out <a href="/$">the codebase</a>.</p>
    <p>Because the entire codebase is web-native, source files are immediately ready for release, are <i>human</i> readable, thus decipherable and <i>hackable</i>.<br>Exercise your right to repair and mod to your heart's desire.</p>
    <p>By using all native web technologies, the necessity for a server or development environment are avoided,<br>and the possibility for writing <i>living</i> web documents is unlocked.</p>
    <h2>"Site Generator"</h2>
    <p>Because Situs makes web authoring simple, some would call this a "<i>static</i> site generator", but we disagree with this and prefer to call it rather just a <b>"site generator"</b>, because:</p><ol type="1">
        <li>Situs provides a mutable container, a _site_ for publishing _dynamic_ web content.
            <ol type="A">
                <li>Situs does not watch a source, having to re-<i>build</i> a static repository for release.</li>
                <li>Situs provides a web-native environment for reading/writing to a dynamic source:
                    <ul>
                        <li>an IPNS name identifying mutable IPFS content addressing the site's source.</li>
                    </ul>
                </li>
            </ol>
        </li>
    </ol><p></p>
    <h2>Development Setup:</h2>
    <p>Because Situs is web-native, for a development environment simply <i>serve</i> the <code>public</code> directory, however you wish.</p>
    <p>The recommendation is to:
        </p><ol type="1">
            <li>Install IPFS Desktop; Enable Brave IPFS node via `brave://ipfs`</li>
            <li>Ensure that Node installed and `http-server` is available globally on the commandline.</li>
            <li>Download or pull the repo.</li>
            <li>From the root of the repo, evoke the scripts defined in package.json:
                <ul>
                    <li><code>npm run dev</code></li>
                    <li><code>npm run release</code></li>
                    <li> . . . </li>
                </ul>
            </li>
        </ol>
    <p></p>
    <h1>Hypertext</h1>
    <p>Hypertext is an instruction notation for modifying the document.</p>
    <p>To initialize an hypertext document, include the script:<br>
        <code>&lt;script type="module" src="/$/module/hypertext.mjs"&gt;</code>
    </p>
    <h3>Hypertext attributes:</h3>
    <ul>
        <li><code>href</code>: declares that the element is hypertext and a new Hypertext class instance should be created.</li>
        <li><code>source</code>: optionally select fragment of hypertext source.</li>
        <li><code>target</code>: optionally select target within parent hypertext to inject element.</li>
    </ul>
    <h3>The Hypertext lifecycle:</h3>
    <ol type="1">
        <li>an <code>.html</code> document with the <code>hypertext.mjs</code> module included is loaded into the browser as usual</li>
        <li>the hypertext module runs, which selects the <code>&lt;html&gt;</code> and declares as hypertext, which initializes a root Hypertext class instance</li>
        <li>if the hypertext element declares the <code>href</code> attribute:
            <ol type="a">
                <li>source is fetched as html string</li>
                <li>html string parsed and rendered as document fragment</li>
                <li>children of hypertext element are merged into fragment</li>
                <li>identifying attributes are used to select target element</li>
                <li>the fragment is merged into the current document at selected target</li>
                <li>elements with <code>href</code> attribute (except: <code>&lt;a&gt;</code>) are selected and initalized as hypertext instances</li>
            </ol>
        </li>
        <li>hypertext element acts "like a component" by employing scoped CSS and applied JS:
            <ol type="a">
                <li>scripts with the <code>scoped</code> attributes are selected and merged</li>
                <li>if an <code>id</code> is not specified, an ID is generated as the hash of the <code>.textContent</code> of the <code>&lt;style scoped&gt;</code></li>
            </ol>
        </li>
        <li>the hypertext instance observes mutations to itself for specific changes that trigger actions:
            <ol type="a">
                <li>mutation of <code>href</code> attribute will trigger the hypertext to re-render and replace its content.</li>
                <li>addition of a `src` attribute to an element:
                    <ul>
                        <li>declares the element to be hypertext, initializing a new Hypertext instance</li>
                    </ul>
                </li>
                <li>removal of the <code>href</code> attribute from an element:
                    <ul>
                        <li>destroys the Hypertext instance leaving the document in its current state:</li>
                    </ul>
                </li>
            </ol>
        </li>
    </ol>

    <h3>Scoped CSS:</h3>
    <p>Each <code>&lt;style scoped&gt;</code> is applied to it's immediate parent.
        </p><ol start="0">
            <li>Immediately disable 'style[scoped]' elements on page load; this avoids the default behavior of the <code>:scope</code> selector, which is synonymous with the <code>:root</code> selector.</li>
            <li>If multiple scoped styles are defined, their textContent is compiled into a single inline style.</li>
            <li>If no ID is specified on the $parent, an ID is generated which is the hash of the textContent of the style and applied to the parent</li>
            <li>instances of the <code>:scope</code> selector are replaced within the textContent with an ID selector</li>
        </ol>
    <p></p>

    <h3>Applied JS:</h3>
    <p>Function constructor and passing the script into, and calling the resulting function, passing the container $element as this . . all the function needs is the selected HTMLElemen</p>
</article>
    </main>
    <footer href="/$/template/footer.html" etag="QmSzZ1GsjN1834bk9znfQVx6ZF7aHgQdsw869hqDS3vn5a" scope="Aly3af3">
    <p>This site is inspired by the <a href="https://astro.build/themes/details/blogster-newspaper" target="_blank">Blogster Newspaper</a> theme,<br>is distributed Peer-to-Peer, powered by <a href="https://ipfs.tech/"><ipfs-icon></ipfs-icon></a>,<br> and best rendered by <a href="https://brave.com/"><brave-color-icon style="height: 2em;"></brave-color-icon></a>.</p>
    <section class="badges">
        <a href="https://creativecommons.org/"><cc-heart-icon></cc-heart-icon></a>
    </section>
    <pre id="copy-left">🄯</pre>
    <a href="https://creativecommons.org/publicdomain/zero/1.0/legalcode">
        <public-domain-badge></public-domain-badge>
    </a>
<style scoped="">
[scope~="Aly3af3"]:is(footer) {
    position: relative;

    & .badges {
        margin-bottom: 20px;
        & a {
            text-decoration: none;
        }
        & .icon {
            width: 2.5em;
            height: 2.5em;
            &:nth-child(2) {
                width: 3.5em;
                height: 3.5em;
                & svg {
                    transform: translate3d(0, 10%, 0);
                }
            }
        }
    }

    & #copy-left {
        position: absolute;
        bottom: 0; left: 0;
        font-size: 2em;
        font-weight: 600;
        margin: 0 0 0.5em 0;
    }

    & cc-zero-icon, public-domain-badge {
        position: absolute;
        bottom: 0; right: 0;
        bottom: 1em;
    }
}
</style>
<script applied="">// <script applied as="$el">
    if (this instanceof Element) {
        const $badges = this.querySelector('.badges')
        $badges.addEventListener('click', () => {
            console.log('Clicked badges!')
        })
    }
</script>
</footer>
  
</body></html>